module.exports = function JsxWrapIf({ types: t }) {
  return {
    visitor: {
      JSXElement: function transform(path) {
        const { node } = path;
        const ifAttributes = node.openingElement.attributes.filter(
          ({ type, name }) => type === "JSXAttribute" && name.name === "wrap-if"
        );

        if (!ifAttributes.length) {
          return;
        }

        const ifAttribute = ifAttributes[0];
        const fragmentMember = t.jsxMemberExpression(
          t.jsxIdentifier("React"),
          t.jsxIdentifier("Fragment")
        );
        const openingFragment = t.jsxOpeningElement(fragmentMember, []);
        const closingFragment = t.jsxClosingElement(fragmentMember);
        const newJsxOpeningElement = t.jsxOpeningElement(
          node.openingElement.name,
          node.openingElement.attributes
            ? node.openingElement.attributes.filter(
                (attr) => attr !== ifAttribute
              )
            : []
        );
        const newJsxElement = t.jsxElement(
          newJsxOpeningElement,
          node.closingElement,
          node.children
        );
        const noWrappingJsxElement = t.jsxElement(
          openingFragment,
          closingFragment,
          node.children
        );
        const conditionalExpression = t.conditionalExpression(
          ifAttribute.value.expression,
          newJsxElement,
          noWrappingJsxElement
        );
        path.replaceWith(conditionalExpression);
      },
    },
  };
};
