const React = require("react");
const Adapter = require("enzyme-adapter-react-16");
const { configure, mount } = require("enzyme");

configure({ adapter: new Adapter() });

describe("test", () => {
  test("wrapping component", () => {
    const wrappedComponent = mount(
      <div wrap-if={true} style={{ backgroundColor: "red" }}>
        <span>A span</span>
        Text
        <label>A label</label>
      </div>
    );

    expect(wrappedComponent.html()).toEqual(
      '<div style="background-color: red;"><span>A span</span>Text<label>A label</label></div>'
    );
  });

  test("no wrapping component", () => {
    const wrappedComponent = mount(
      <div wrap-if={false} style={{ backgroundColor: "red" }}>
        <span>A span</span>
        Text
        <label>A label</label>
      </div>
    );

    expect(wrappedComponent.length).toEqual(3);
    expect(wrappedComponent.at(0).html()).toEqual("<span>A span</span>");
    expect(wrappedComponent.at(1).html()).toEqual("Text");
    expect(wrappedComponent.at(2).html()).toEqual("<label>A label</label>");
  });
});
